<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (38)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="numbers">Numbers</h1>
    <p>In modern JavaScript, there are two types of numbers:</p>
    <ol type="1">
      <li>
        <p>
          Regular numbers in JavaScript are stored in 64-bit format
          <a href="https://en.wikipedia.org/wiki/IEEE_754-2008_revision"
            >IEEE-754</a
          >, also known as “double precision floating point numbers”. These are
          numbers that we’re using most of the time, and we’ll talk about them
          in this chapter.
        </p>
      </li>
      <li>
        <p>
          BigInt numbers, to represent integers of arbitrary length. They are
          sometimes needed, because a regular number can’t exceed
          <code>2<sup>53</sup></code> or be less than
          <code>-2<sup>53</sup></code
          >. As bigints are used in few special areas, we devote them a special
          chapter <a href="info:bigint" class="uri">info:bigint</a>.
        </p>
      </li>
    </ol>
    <p>
      So here we’ll talk about regular numbers. Let’s expand our knowledge of
      them.
    </p>
    <h2 id="more-ways-to-write-a-number">More ways to write a number</h2>
    <p>Imagine we need to write 1 billion. The obvious way is:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> billion <span class="op">=</span> <span class="dv">1000000000</span><span class="op">;</span></a></code></pre>
    </div>
    <p>We also can use underscore <code>_</code> as the separator:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> billion <span class="op">=</span> <span class="dv">1</span>_000_000_000<span class="op">;</span></a></code></pre>
    </div>
    <p>
      Here the underscore <code>_</code> plays the role of the “syntactic
      sugar”, it makes the number more readable. The JavaScript engine simply
      ignores <code>_</code> between digits, so it’s exactly the same one
      billion as above.
    </p>
    <p>
      In real life though, we try to avoid writing long sequences of zeroes.
      We’re too lazy for that. We’ll try to write something like
      <code>"1bn"</code> for a billion or <code>"7.3bn"</code> for 7 billion 300
      million. The same is true for most large numbers.
    </p>
    <p>
      In JavaScript, we can shorten a number by appending the letter
      <code>"e"</code> to it and specifying the zeroes count:
    </p>
    <p>```js run let billion = 1e9; // 1 billion, literally: 1 and 9 zeroes</p>
    <p>
      alert(7.3e9); // 7.3 billions (same as 7300000000 or 7_300_000_000) ```
    </p>
    <p>
      In other words, <code>e</code> multiplies the number by
      <code>1</code> with the given zeroes count.
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="fl">1e3</span> <span class="op">=</span> <span class="dv">1</span> <span class="op">*</span> <span class="dv">1000</span> <span class="co">// e3 means *1000</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="fl">1.23e6</span> <span class="op">=</span> <span class="fl">1.23</span> <span class="op">*</span> <span class="dv">1000000</span> <span class="co">// e6 means *1000000</span></a></code></pre>
    </div>
    <p>
      Now let’s write something very small. Say, 1 microsecond (one millionth of
      a second):
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">let</span> ms <span class="op">=</span> <span class="fl">0.000001</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      Just like before, using <code>"e"</code> can help. If we’d like to avoid
      writing the zeroes explicitly, we could say the same as:
    </p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">let</span> ms <span class="op">=</span> <span class="fl">1e-6</span><span class="op">;</span> <span class="co">// six zeroes to the left from 1</span></a></code></pre>
    </div>
    <p>
      If we count the zeroes in <code>0.000001</code>, there are 6 of them. So
      naturally it’s <code>1e-6</code>.
    </p>
    <p>
      In other words, a negative number after <code>"e"</code> means a division
      by 1 with the given number of zeroes:
    </p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="co">// -3 divides by 1 with 3 zeroes</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="fl">1e-3</span> <span class="op">=</span> <span class="dv">1</span> / <span class="dv">1000</span> (<span class="op">=</span><span class="fl">0.001</span>)</a>
<a class="sourceLine" id="cb6-3" title="3"></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="co">// -6 divides by 1 with 6 zeroes</span></a>
<a class="sourceLine" id="cb6-5" title="5"><span class="fl">1.23e-6</span> <span class="op">=</span> <span class="fl">1.23</span> / <span class="dv">1000000</span> (<span class="op">=</span><span class="fl">0.00000123</span>)</a></code></pre>
    </div>
    <h3 id="hex-binary-and-octal-numbers">Hex, binary and octal numbers</h3>
    <p>
      <a href="https://en.wikipedia.org/wiki/Hexadecimal">Hexadecimal</a>
      numbers are widely used in JavaScript to represent colors, encode
      characters, and for many other things. So naturally, there exists a
      shorter way to write them: <code>0x</code> and then the number.
    </p>
    <p>For instance:</p>
    <p>
      <code
        >js run alert(0xff); // 255 alert(0xff); // 255 (the same, case doesn't
        matter)</code
      >
    </p>
    <p>
      Binary and octal numeral systems are rarely used, but also supported using
      the <code>0b</code> and <code>0o</code> prefixes:
    </p>
    <p>
      ```js run let a = 0b11111111; // binary form of 255 let b = 0o377; //
      octal form of 255
    </p>
    <p>alert(a == b); // true, the same number 255 at both sides ```</p>
    <p>
      There are only 3 numeral systems with such support. For other numeral
      systems, we should use the function <code>parseInt</code> (which we will
      see later in this chapter).
    </p>
    <h2 id="tostringbase">toString(base)</h2>
    <p>
      The method <code>num.toString(base)</code> returns a string representation
      of <code>num</code> in the numeral system with the given
      <code>base</code>.
    </p>
    <p>For example:</p>
    <p>```js run let num = 255;</p>
    <p>
      alert(num.toString(16)); // ff alert(num.toString(2)); // 11111111 ```
    </p>
    <p>
      The <code>base</code> can vary from <code>2</code> to <code>36</code>. By
      default it’s <code>10</code>.
    </p>
    <p>Common use cases for this are:</p>
    <ul>
      <li>
        <strong>base=16</strong> is used for hex colors, character encodings
        etc, digits can be <code>0..9</code> or <code>A..F</code>.
      </li>
      <li>
        <strong>base=2</strong> is mostly for debugging bitwise operations,
        digits can be <code>0</code> or <code>1</code>.
      </li>
      <li>
        <p>
          <strong>base=36</strong> is the maximum, digits can be
          <code>0..9</code> or <code>A..Z</code>. The whole latin alphabet is
          used to represent a number. A funny, but useful case for
          <code>36</code> is when we need to turn a long numeric identifier into
          something shorter, for example to make a short url. Can simply
          represent it in the numeral system with base <code>36</code>:
        </p>
        <p><code>js run alert((123456).toString(36)); // 2n9c</code></p>
      </li>
    </ul>
    <p>
      ``<code
        >warn header="Two dots to call a method" Please note that two dots
        in</code
      >123456..toString(36)<code
        >is not a typo. If we want to call a method directly on a number,
        like</code
      >toString<code>in the example above, then we need to place two dots</code
      >..` after it.
    </p>
    <p>
      If we placed a single dot: <code>123456.toString(36)</code>, then there
      would be an error, because JavaScript syntax implies the decimal part
      after the first dot. And if we place one more dot, then JavaScript knows
      that the decimal part is empty and now goes the method.
    </p>
    <p>Also could write <code>(123456).toString(36)</code>. ```</p>
    <h2 id="rounding">Rounding</h2>
    <p>
      One of the most used operations when working with numbers is rounding.
    </p>
    <p>There are several built-in functions for rounding:</p>
    <dl>
      <dt><code>Math.floor</code></dt>
      <dd>
        Rounds down: <code>3.1</code> becomes <code>3</code>, and
        <code>-1.1</code> becomes <code>-2</code>.
      </dd>
      <dt><code>Math.ceil</code></dt>
      <dd>
        Rounds up: <code>3.1</code> becomes <code>4</code>, and
        <code>-1.1</code> becomes <code>-1</code>.
      </dd>
      <dt><code>Math.round</code></dt>
      <dd>
        Rounds to the nearest integer: <code>3.1</code> becomes <code>3</code>,
        <code>3.6</code> becomes <code>4</code>, the middle case:
        <code>3.5</code> rounds up to <code>4</code> too.
      </dd>
      <dt><code>Math.trunc</code> (not supported by Internet Explorer)</dt>
      <dd>
        Removes anything after the decimal point without rounding:
        <code>3.1</code> becomes <code>3</code>, <code>-1.1</code> becomes
        <code>-1</code>.
      </dd>
    </dl>
    <p>Here’s the table to summarize the differences between them:</p>
    <table>
      <thead>
        <tr class="header">
          <th></th>
          <th><code>Math.floor</code></th>
          <th><code>Math.ceil</code></th>
          <th><code>Math.round</code></th>
          <th><code>Math.trunc</code></th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>3.1</code></td>
          <td><code>3</code></td>
          <td><code>4</code></td>
          <td><code>3</code></td>
          <td><code>3</code></td>
        </tr>
        <tr class="even">
          <td><code>3.6</code></td>
          <td><code>3</code></td>
          <td><code>4</code></td>
          <td><code>4</code></td>
          <td><code>3</code></td>
        </tr>
        <tr class="odd">
          <td><code>-1.1</code></td>
          <td><code>-2</code></td>
          <td><code>-1</code></td>
          <td><code>-1</code></td>
          <td><code>-1</code></td>
        </tr>
        <tr class="even">
          <td><code>-1.6</code></td>
          <td><code>-2</code></td>
          <td><code>-1</code></td>
          <td><code>-2</code></td>
          <td><code>-1</code></td>
        </tr>
      </tbody>
    </table>
    <p>
      These functions cover all of the possible ways to deal with the decimal
      part of a number. But what if we’d like to round the number to
      <code>n-th</code> digit after the decimal?
    </p>
    <p>
      For instance, we have <code>1.2345</code> and want to round it to 2
      digits, getting only <code>1.23</code>.
    </p>
    <p>There are two ways to do so:</p>
    <ol type="1">
      <li>
        <p>Multiply-and-divide.</p>
        <p>
          For example, to round the number to the 2nd digit after the decimal,
          we can multiply the number by <code>100</code> (or a bigger power of
          10), call the rounding function and then divide it back.
        </p>
        <p>```js run let num = 1.23456;</p>
        <p>
          alert(Math.round(num * 100) / 100); // 1.23456 -&gt; 123.456 -&gt; 123
          -&gt; 1.23 ```
        </p>
      </li>
      <li>
        <p>
          The method
          <a
            href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/toFixed"
            >toFixed(n)</a
          >
          rounds the number to <code>n</code> digits after the point and returns
          a string representation of the result.
        </p>
        <p>
          <code>js run let num = 12.34; alert(num.toFixed(1)); // "12.3"</code>
        </p>
        <p>
          This rounds up or down to the nearest value, similar to
          <code>Math.round</code>:
        </p>
        <p>
          <code>js run let num = 12.36; alert(num.toFixed(1)); // "12.4"</code>
        </p>
        <p>
          Please note that result of <code>toFixed</code> is a string. If the
          decimal part is shorter than required, zeroes are appended to the end:
        </p>
        <p>
          <code
            >js run let num = 12.34; alert(num.toFixed(5)); // "12.34000", added
            zeroes to make exactly 5 digits</code
          >
        </p>
        <p>
          We can convert it to a number using the unary plus or a
          <code>Number()</code> call: <code>+num.toFixed(5)</code>.
        </p>
      </li>
    </ol>
    <h2 id="imprecise-calculations">Imprecise calculations</h2>
    <p>
      Internally, a number is represented in 64-bit format
      <a href="https://en.wikipedia.org/wiki/IEEE_754-2008_revision">IEEE-754</a
      >, so there are exactly 64 bits to store a number: 52 of them are used to
      store the digits, 11 of them store the position of the decimal point (they
      are zero for integer numbers), and 1 bit is for the sign.
    </p>
    <p>
      If a number is too big, it would overflow the 64-bit storage, potentially
      giving an infinity:
    </p>
    <p><code>js run alert(1e500); // Infinity</code></p>
    <p>
      What may be a little less obvious, but happens quite often, is the loss of
      precision.
    </p>
    <p>Consider this (falsy!) test:</p>
    <p><code>js run alert(0.1 + 0.2 == 0.3); // *!*false*/!*</code></p>
    <p>
      That’s right, if we check whether the sum of <code>0.1</code> and
      <code>0.2</code> is <code>0.3</code>, we get <code>false</code>.
    </p>
    <p>Strange! What is it then if not <code>0.3</code>?</p>
    <p><code>js run alert(0.1 + 0.2); // 0.30000000000000004</code></p>
    <p>
      Ouch! There are more consequences than an incorrect comparison here.
      Imagine you’re making an e-shopping site and the visitor puts
      <code>$0.10</code> and <code>$0.20</code> goods into their cart. The order
      total will be <code>$0.30000000000000004</code>. That would surprise
      anyone.
    </p>
    <p>But why does this happen?</p>
    <p>
      A number is stored in memory in its binary form, a sequence of bits - ones
      and zeroes. But fractions like <code>0.1</code>, <code>0.2</code> that
      look simple in the decimal numeric system are actually unending fractions
      in their binary form.
    </p>
    <p>
      In other words, what is <code>0.1</code>? It is one divided by ten
      <code>1/10</code>, one-tenth. In decimal numeral system such numbers are
      easily representable. Compare it to one-third: <code>1/3</code>. It
      becomes an endless fraction <code>0.33333(3)</code>.
    </p>
    <p>
      So, division by powers <code>10</code> is guaranteed to work well in the
      decimal system, but division by <code>3</code> is not. For the same
      reason, in the binary numeral system, the division by powers of
      <code>2</code> is guaranteed to work, but <code>1/10</code> becomes an
      endless binary fraction.
    </p>
    <p>
      There’s just no way to store <em>exactly 0.1</em> or
      <em>exactly 0.2</em> using the binary system, just like there is no way to
      store one-third as a decimal fraction.
    </p>
    <p>
      The numeric format IEEE-754 solves this by rounding to the nearest
      possible number. These rounding rules normally don’t allow us to see that
      “tiny precision loss”, but it exists.
    </p>
    <p>We can see this in action:</p>
    <p>
      <code>js run alert((0.1).toFixed(20)); // 0.10000000000000000555</code>
    </p>
    <p>And when we sum two numbers, their “precision losses” add up.</p>
    <p>That’s why <code>0.1 + 0.2</code> is not exactly <code>0.3</code>.</p>
    <p>
      ```smart header=“Not only JavaScript” The same issue exists in many other
      programming languages.
    </p>
    <p>
      PHP, Java, C, Perl, Ruby give exactly the same result, because they are
      based on the same numeric format. ```
    </p>
    <p>
      Can we work around the problem? Sure, the most reliable method is to round
      the result with the help of a method
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/toFixed"
        >toFixed(n)</a
      >:
    </p>
    <p>
      <code>js run let sum = 0.1 + 0.2; alert(sum.toFixed(2)); // 0.30</code>
    </p>
    <p>
      Please note that <code>toFixed</code> always returns a string. It ensures
      that it has 2 digits after the decimal point. That’s actually convenient
      if we have an e-shopping and need to show <code>$0.30</code>. For other
      cases, we can use the unary plus to coerce it into a number:
    </p>
    <p>
      <code>js run let sum = 0.1 + 0.2; alert(+sum.toFixed(2)); // 0.3</code>
    </p>
    <p>
      We also can temporarily multiply the numbers by 100 (or a bigger number)
      to turn them into integers, do the maths, and then divide back. Then, as
      we’re doing maths with integers, the error somewhat decreases, but we
      still get it on division:
    </p>
    <p>
      <code
        >js run alert((0.1 * 10 + 0.2 * 10) / 10); // 0.3 alert((0.28 * 100 +
        0.14 * 100) / 100); // 0.4200000000000001</code
      >
    </p>
    <p>
      So, multiply/divide approach reduces the error, but doesn’t remove it
      totally.
    </p>
    <p>
      Sometimes we could try to evade fractions at all. Like if we’re dealing
      with a shop, then we can store prices in cents instead of dollars. But
      what if we apply a discount of 30%? In practice, totally evading fractions
      is rarely possible. Just round them to cut “tails” when needed.
    </p>
    <p>````smart header=“The funny thing” Try running this:</p>
    <p>
      <code
        >js run // Hello! I'm a self-increasing number! alert( 9999999999999999
        ); // shows 10000000000000000</code
      >
    </p>
    <p>
      This suffers from the same issue: a loss of precision. There are 64 bits
      for the number, 52 of them can be used to store digits, but that’s not
      enough. So the least significant digits disappear.
    </p>
    <p>
      JavaScript doesn’t trigger an error in such events. It does its best to
      fit the number into the desired format, but unfortunately, this format is
      not big enough.
    </p>
    <pre><code>
```smart header=&quot;Two zeroes&quot;
Another funny consequence of the internal representation of numbers is the existence of two zeroes: `0` and `-0`.

That&#39;s because a sign is represented by a single bit, so it can be set or not set for any number including a zero.

In most cases the distinction is unnoticeable, because operators are suited to treat them as the same.
```

## Tests: isFinite and isNaN

Remember these two special numeric values?

- `Infinity` (and `-Infinity`) is a special numeric value that is greater (less) than anything.
- `NaN` represents an error.

They belong to the type `number`, but are not &quot;normal&quot; numbers, so there are special functions to check for them:

- `isNaN(value)` converts its argument to a number and then tests it for being `NaN`:

  ```js run
  alert(isNaN(NaN)); // true
  alert(isNaN(&quot;str&quot;)); // true
  ```

  But do we need this function? Can&#39;t we just use the comparison `=== NaN`? Sorry, but the answer is no. The value `NaN` is unique in that it does not equal anything, including itself:

  ```js run
  alert(NaN === NaN); // false
  ```

- `isFinite(value)` converts its argument to a number and returns `true` if it&#39;s a regular number, not `NaN/Infinity/-Infinity`:

  ```js run
  alert(isFinite(&quot;15&quot;)); // true
  alert(isFinite(&quot;str&quot;)); // false, because a special value: NaN
  alert(isFinite(Infinity)); // false, because a special value: Infinity
  ```

Sometimes `isFinite` is used to validate whether a string value is a regular number:

```js run
let num = +prompt(&quot;Enter a number&quot;, &quot;&quot;);

// will be true unless you enter Infinity, -Infinity or not a number
alert(isFinite(num));
```

Please note that an empty or a space-only string is treated as `0` in all numeric functions including `isFinite`.

```smart header=&quot;Compare with `Object.is`&quot;

There is a special built-in method [`Object.is`](mdn:js/Object/is) that compares values like `===`, but is more reliable for two edge cases:

1. It works with `NaN`: `Object.is(NaN, NaN) === true`, that&#39;s a good thing.
2. Values `0` and `-0` are different: `Object.is(0, -0) === false`, technically that&#39;s true, because internally the number has a sign bit that may be different even if all other bits are zeroes.

In all other cases, `Object.is(a, b)` is the same as `a === b`.

This way of comparison is often used in JavaScript specification. When an internal algorithm needs to compare two values for being exactly the same, it uses `Object.is` (internally called [SameValue](https://tc39.github.io/ecma262/#sec-samevalue)).
</code></pre>
    <h2 id="parseint-and-parsefloat">parseInt and parseFloat</h2>
    <p>
      Numeric conversion using a plus <code>+</code> or <code>Number()</code> is
      strict. If a value is not exactly a number, it fails:
    </p>
    <p>```js run alert( +“100px” ); // NaN ````</p>
    <p>
      The sole exception is spaces at the beginning or at the end of the string,
      as they are ignored.
    </p>
    <p>
      But in real life we often have values in units, like
      <code>"100px"</code> or <code>"12pt"</code> in CSS. Also in many countries
      the currency symbol goes after the amount, so we have
      <code>"19€"</code> and would like to extract a numeric value out of that.
    </p>
    <p>
      That’s what <code>parseInt</code> and <code>parseFloat</code> are for.
    </p>
    <p>
      They “read” a number from a string until they can’t. In case of an error,
      the gathered number is returned. The function
      <code>parseInt</code> returns an integer, whilst
      <code>parseFloat</code> will return a floating-point number:
    </p>
    <p>
      ```js run alert(parseInt(“100px”)); // 100 alert(parseFloat(“12.5em”)); //
      12.5
    </p>
    <p>
      alert(parseInt(“12.3”)); // 12, only the integer part is returned
      alert(parseFloat(“12.3.4”)); // 12.3, the second point stops the reading
      ```
    </p>
    <p>
      There are situations when <code>parseInt/parseFloat</code> will return
      <code>NaN</code>. It happens when no digits could be read:
    </p>
    <p>
      <code
        >js run alert(parseInt("a123")); // NaN, the first symbol stops the
        process</code
      >
    </p>
    <p>
      ```<code>smart header="The second argument of</code>parseInt(str,
      radix)<code>" The</code>parseInt()<code
        >function has an optional second parameter. It specifies the base of the
        numeral system, so</code
      >parseInt` can also parse strings of hex numbers, binary numbers and so
      on:
    </p>
    <p>
      ```js run alert(parseInt(“0xff”, 16)); // 255 alert(parseInt(“ff”, 16));
      // 255, without 0x also works
    </p>
    <p>alert(parseInt(“2n9c”, 36)); // 123456</p>
    <pre><code></code></pre>
    <h2 id="other-math-functions">Other math functions</h2>
    <p>
      JavaScript has a built-in
      <a
        href="https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Math"
        >Math</a
      >
      object which contains a small library of mathematical functions and
      constants.
    </p>
    <p>A few examples:</p>
    <dl>
      <dt><code>Math.random()</code></dt>
      <dd>
        <p>Returns a random number from 0 to 1 (not including 1).</p>
        <p>
          <code
            >js run alert( Math.random() ); // 0.1234567894322 alert(
            Math.random() ); // 0.5435252343232 alert( Math.random() ); // ...
            (any random numbers)</code
          >
        </p>
      </dd>
      <dt>
        <code>Math.max(a, b, c...)</code> / <code>Math.min(a, b, c...)</code>
      </dt>
      <dd>
        <p>
          Returns the greatest/smallest from the arbitrary number of arguments.
        </p>
        <p>
          <code
            >js run alert( Math.max(3, 5, -10, 0, 1) ); // 5 alert( Math.min(1,
            2) ); // 1</code
          >
        </p>
      </dd>
      <dt><code>Math.pow(n, power)</code></dt>
      <dd>
        <p>Returns <code>n</code> raised to the given power.</p>
        <p>
          <code>js run alert( Math.pow(2, 10) ); // 2 in power 10 = 1024</code>
        </p>
      </dd>
    </dl>
    <p>
      There are more functions and constants in <code>Math</code> object,
      including trigonometry, which you can find in the
      <a
        href="https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Math"
        >docs for the Math object</a
      >.
    </p>
    <h2 id="summary">Summary</h2>
    <p>To write numbers with many zeroes:</p>
    <ul>
      <li>
        Append <code>"e"</code> with the zeroes count to the number. Like:
        <code>123e6</code> is the same as <code>123</code> with 6 zeroes
        <code>123000000</code>.
      </li>
      <li>
        A negative number after <code>"e"</code> causes the number to be divided
        by 1 with given zeroes. E.g. <code>123e-6</code> means
        <code>0.000123</code> (<code>123</code> millionths).
      </li>
    </ul>
    <p>For different numeral systems:</p>
    <ul>
      <li>
        Can write numbers directly in hex (<code>0x</code>), octal
        (<code>0o</code>) and binary (<code>0b</code>) systems.
      </li>
      <li>
        <code>parseInt(str, base)</code> parses the string <code>str</code> into
        an integer in numeral system with given <code>base</code>,
        <code>2 ≤ base ≤ 36</code>.
      </li>
      <li>
        <code>num.toString(base)</code> converts a number to a string in the
        numeral system with the given <code>base</code>.
      </li>
    </ul>
    <p>
      For converting values like <code>12pt</code> and <code>100px</code> to a
      number:
    </p>
    <ul>
      <li>
        Use <code>parseInt/parseFloat</code> for the “soft” conversion, which
        reads a number from a string and then returns the value they could read
        before the error.
      </li>
    </ul>
    <p>For fractions:</p>
    <ul>
      <li>
        Round using <code>Math.floor</code>, <code>Math.ceil</code>,
        <code>Math.trunc</code>, <code>Math.round</code> or
        <code>num.toFixed(precision)</code>.
      </li>
      <li>
        Make sure to remember there’s a loss of precision when working with
        fractions.
      </li>
    </ul>
    <p>More mathematical functions:</p>
    <ul>
      <li>
        See the
        <a
          href="https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Math"
          >Math</a
        >
        object when you need them. The library is very small, but can cover
        basic needs. ````
      </li>
    </ul>
  </body>
</html>
